package com.loafle.commons.rpc.protocol.json;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import com.google.gson.internal.Primitives;
import com.loafle.commons.rpc.RPCException;

import org.codehaus.jackson.map.ObjectMapper;

/**
 * JSONUtil
 */
public abstract class JSONUtil {
  public static List<String> convertParamsToStringArray(ObjectMapper objectMapper, Object[] params)
      throws RPCException {
    List<String> values = new ArrayList<>();
    if (null == params || 0 == params.length) {
      return values;
    }

    try {
      for (Object param : params) {
        Class<?> clazz = param.getClass();
        if (!Primitives.isPrimitive(clazz) && !clazz.equals(String.class)) {
          values.add(objectMapper.writeValueAsString(param));
        } else {
          values.add(String.valueOf(param));
        }
      }
    } catch (IOException e) {
      throw new RPCException("cannot unmarsharling", e);
    }

    return values;
  }
}